﻿using LawFirmContracts.BindingModels;
using LawFirmContracts.ViewModels;
using System.Collections.Generic;

namespace LawFirmContracts.BusinessLogicsContracts
{
    public interface IReportLogic
    {
        /// <summary>
        /// Получение списка компонент с указанием, в каких изделиях используются
        /// </summary>
        /// <returns></returns>
        List<ReportDocumentBlankViewModel> GetDocumentBlank();
		List<ReportShopDocumentViewModel> GetShopDocuments();
		List<ReportOrdersGroupedByDateViewModel> GetGroupedByDateOrders();
		/// <summary>
		/// Получение списка заказов за определенный период
		/// </summary>
		/// <param name="model"></param>
		/// <returns></returns>
		List<ReportOrdersViewModel> GetOrders(ReportBindingModel model);
        /// <summary>
        /// Сохранение компонент в файл-Word
        /// </summary>
        /// <param name="model"></param>
        void SaveBlanksToWordFile(ReportBindingModel model);
		void SaveShopsToWordFile(ReportBindingModel model);
		/// <summary>
		/// Сохранение компонент с указаеним продуктов в файл-Excel
		/// </summary>
		/// <param name="model"></param>
		void SaveDocumentBlankToExcelFile(ReportBindingModel model);
		void SaveShopDocumentToExcelFile(ReportBindingModel model);
		/// <summary>
		/// Сохранение заказов в файл-Pdf
		/// </summary>
		/// <param name="model"></param>
		void SaveOrdersToPdfFile(ReportBindingModel model);
		void SaveGroupedByDateOrders(ReportBindingModel model);
	}
}
